'use strict';

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = generateIncludes;

var _argsToFindOptions = require('./argsToFindOptions');

var _argsToFindOptions2 = _interopRequireDefault(_argsToFindOptions);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function generateIncludes(simpleAST, type, root, options) {
  var result = { include: [], attributes: [] };

  type = type.ofType || type;
  options = options || {};
  if (options.include === undefined) options.include = true;

  _Object$keys(simpleAST).forEach(function (key) {
    var association,
        includeOptions,
        args = simpleAST[key].args,
        includeResolver = type._fields[key].resolve,
        nestedResult,
        allowedAttributes;

    if (!includeResolver) return;

    if (includeResolver.$proxy) {
      while (includeResolver.$proxy) {
        includeResolver = includeResolver.$proxy;
      }
    }

    if (includeResolver.$passthrough) {
      var dummyResult = generateIncludes(simpleAST[key].fields, type._fields[key].type, root);
      result.include = result.include.concat(dummyResult.include);
      return;
    }

    association = includeResolver.$association;

    if (association) {
      includeOptions = (0, _argsToFindOptions2['default'])(args, association.target);
      allowedAttributes = _Object$keys(association.target.rawAttributes);

      if (includeResolver.$before) {
        includeOptions = includeResolver.$before(includeOptions, args, root, {
          ast: simpleAST,
          type: type
        });
      }

      if (options.include && !includeOptions.limit) {
        if (includeOptions.order) {
          includeOptions.order.map(function (order) {
            order.unshift({
              model: association.target,
              as: association.options.as
            });

            return order;
          });

          result.order = (result.order || []).concat(includeOptions.order);
          delete includeOptions.order;
        }

        includeOptions.attributes = _Object$keys(simpleAST[key].fields).filter(function (attribute) {
          return ~allowedAttributes.indexOf(attribute);
        });

        includeOptions.attributes.push(association.target.primaryKeyAttribute);

        nestedResult = generateIncludes(simpleAST[key].fields, type._fields[key].type, root, includeResolver.$options);

        includeOptions.include = (includeOptions.include || []).concat(nestedResult.include);
        includeOptions.attributes = _lodash2['default'].unique(includeOptions.attributes.concat(nestedResult.attributes));

        result.include.push(_lodash2['default'].assign({ association: association }, includeOptions));
      } else if (association.associationType === 'BelongsTo') {
        result.attributes.push(association.foreignKey);
      } else {
        result.attributes.push(association.source.primaryKeyAttribute);
      }
    }
  });

  return result;
}

module.exports = exports['default'];